Attribute VB_Name = "Module1"
Option Explicit

Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wFlag As Long) As Long
Declare Function GetClassName Lib "user32.dll" Alias "GetClassNameA" _
    (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Declare Function GetWindowText Lib "user32.dll" Alias "GetWindowTextA" _
   (ByVal hWnd As Long, ByVal lpString As String, ByVal nMaxCount As Long) As Long
Declare Function SetThreadExecutionState Lib "kernel32.dll" (ByVal esFlags As Long) As Long
Declare Function EnumWindows Lib "user32" _
    (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Declare Function IsWindowVisible Lib "user32" _
    (ByVal hWnd As Long) As Long
Declare Function SetForegroundWindow Lib "user32" _
    (ByVal hWnd As Long) As Long
Declare Function SetWindowPos Lib "user32" _
   (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, _
    ByVal cy As Long, ByVal wFlags As Long) As Long

Public Const ES_SYSTEM_REQUIRED = &H1
Public Const ES_DISPLAY_REQUIRED = &H2
Public Const ES_CONTINUOUS = &H80000000
Public Const GW_OWNER = 4
Public Const HWND_TOPMOST = (-1)
Public Const SWP_NOSIZE = &H1&
Public Const SWP_NOMOVE = &H2&




Public Function EnumWndProc(ByVal hWnd As Long, lParam As Long) As Boolean
    Dim strWindowName As String * 128
    Dim strClassName As String * 128
    Dim lngRet As Long
    Dim WinTitle As String
    
    WinTitle = Form1.Text1.Text
    strWindowName = ""
    strClassName = ""
    lngRet = GetWindowText(hWnd, strWindowName, Len(strWindowName))
    Call GetClassName(hWnd, strClassName, Len(strClassName))

    If IsWindowVisible(hWnd) Then
        If GetWindow(hWnd, GW_OWNER) = 0 Then
            If lngRet <> 0 Then
                If Left(strClassName, 7) <> "Progman" Then
                    If WinTitle <> vbNullString And InStr(strWindowName, WinTitle) > 0 Then
                        SetThreadExecutionState (ES_SYSTEM_REQUIRED Or ES_DISPLAY_REQUIRED)
                        SetForegroundWindow (hWnd)
                        lngRet = SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
                        Debug.Print "Window Name = " & strWindowName
                    End If
                End If
            End If
        End If
    End If
    EnumWndProc = True
End Function

Public Function MyGetWindowText(hWnd As Long) As String
    Dim Buffer As String * 512
    Dim lngRt As Long
    
    lngRt = GetWindowText(hWnd, Buffer, Len(Buffer))
    MyGetWindowText = Left(Buffer, InStr(Buffer, vbNullChar) - 1)
End Function

