Attribute VB_Name = "Module2"
Option Explicit

Public udtNotifyIconData As NOTIFYICONDATA

Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Public Const NIF_ICON = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_TIP = &H4

Public Const NIM_ADD = &H0
Public Const NIM_DELETE = &H2
Public Const NIM_MODIFY = &H1

Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205

Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long

Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" _
    (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

' ------------------------------------------------------------------------
'
' ֐    : AddTaskTray
' Ԃl    : 
'     : myForm(i)    :etH[imew肷j
'           : strToolTip(i):c[`bv
' @\  : ^XNgCɃACRǉ
'
Public Sub AddTaskTray(myForm As Form, strToolTip As String)
    Dim NID As NOTIFYICONDATA
    NID.cbSize = Len(NID)
    NID.hIcon = myForm.Icon.Handle
    NID.hwnd = myForm.hwnd
    NID.szTip = strToolTip & Chr(0)
    NID.uCallbackMessage = WM_MOUSEMOVE
    NID.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    NID.uID = 1
    Shell_NotifyIcon NIM_ADD, NID
End Sub
'
' ֐    : ModTaskTray
' Ԃl    : 
'     : myForm(i)    :etH[imew肷j
'           : strToolTip(i):c[`bv
' @\  : ^XNgCɃACRǉ
'
Public Sub ModTaskTray(myForm As Form, strToolTip As String)
    Dim NID As NOTIFYICONDATA
    NID.cbSize = Len(NID)
    NID.hIcon = myForm.Icon.Handle
    NID.hwnd = myForm.hwnd
    NID.szTip = strToolTip & Chr(0)
    NID.uCallbackMessage = WM_MOUSEMOVE
    NID.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    NID.uID = 1
    Shell_NotifyIcon NIM_MODIFY, NID
End Sub
'
' ֐    : DelTaskTray
' Ԃl    : 
'     : myForm(i):etH[imew肷j
' @\  : ^XNgCACR폜
'
Public Sub DelTaskTray(myForm As Form)
    Dim NID As NOTIFYICONDATA
    NID.cbSize = Len(NID)
    NID.hIcon = 0
    NID.hwnd = myForm.hwnd
    NID.szTip = ""
    NID.uCallbackMessage = WM_MOUSEMOVE
    NID.uFlags = 0
    NID.uID = 1
    Shell_NotifyIcon NIM_DELETE, NID
End Sub

